# Draws the 2-plane field associated to the input 1-form.
# Matt Scholl and Ken Baker 


require 'sketchup.rb'
include(Math)

	  $formula ||= 0

class Sketchup::Entities
  def add_box(cpt, size)
    add_face([cpt.x + size,cpt.y + size,cpt.z + size],[cpt.x + size,cpt.y - size,cpt.z + size],[cpt.x + size,cpt.y + size,cpt.z - size],[cpt.x + size,cpt.y - size,cpt.z - size]) #+x
    add_face([cpt.x - size,cpt.y + size,cpt.z + size],[cpt.x - size,cpt.y - size,cpt.z + size],[cpt.x - size,cpt.y + size,cpt.z - size],[cpt.x - size,cpt.y - size,cpt.z - size]) #-x
    add_face([cpt.x + size,cpt.y + size,cpt.z + size],[cpt.x - size,cpt.y + size,cpt.z + size],[cpt.x + size,cpt.y + size,cpt.z - size],[cpt.x - size,cpt.y + size,cpt.z - size]) #+y
    add_face([cpt.x + size,cpt.y - size,cpt.z + size],[cpt.x - size,cpt.y - size,cpt.z + size],[cpt.x + size,cpt.y - size,cpt.z - size],[cpt.x - size,cpt.y - size,cpt.z - size]) #-y
    add_face([cpt.x + size,cpt.y + size,cpt.z + size],[cpt.x - size,cpt.y + size,cpt.z + size],[cpt.x + size,cpt.y - size,cpt.z + size],[cpt.x - size,cpt.y - size,cpt.z + size]) #+z
    add_face([cpt.x + size,cpt.y + size,cpt.z - size],[cpt.x - size,cpt.y + size,cpt.z - size],[cpt.x + size,cpt.y - size,cpt.z - size],[cpt.x - size,cpt.y - size,cpt.z - size]) #-z
  end
end




    
    

def graph_vector_field
    #-----------------------------------------------------------------------------
    model = Sketchup.active_model
    model.start_operation "Graph Vector Field"
    #-----------------------------------------------------------------------------
    entities = model.active_entities
    group = entities.add_group
    entities = group.entities
    #-----------------------------------------------------------------------------   
    materials=model.materials
    
    hazyyellow_material = materials.add("hazy yellow")
    hazyyellow_material.color = 127, 127, 0
    hazyyellow_material.alpha = 0.5

	hazygreen_material = materials.add("hazy green")
    hazygreen_material.color = 0, 127, 0
    hazygreen_material.alpha = 0.5	
    #-----------------------------------------------------------------------------   

    
    
    
    prompts = ["Graph Vector Field"]
    Sketchup::set_status_text("Graph Vector Field", SB_PROMPT)

    box_center ||= [0.0, 0.0, 0.0].inspect
    box_size ||= 10.0
    box_grain ||= 2.0

    prompts = ["Box center:", "Box length:", "Box res:"]
    values = [box_center, box_size, box_grain]
    results = inputbox(prompts, values, "Range and Resolution")
    box_center, box_size, box_grain = results
    box_center = eval(box_center)
#    UI.messagebox(prompts.inspect + [box_center, box_size, box_grain].inspect)

    formula ||= "[-y, 0, 1]" 
    prompts = ["Formula [(dx),(dy),(dz)]:         "]
    values = [formula]
    results = inputbox(prompts, values, "1-form formula")
    formula = results[0]

#    UI.messagebox(formula)
    
    xbeg = box_center[0] - 0.5 * box_size
    ybeg = box_center[1] - 0.5 * box_size
    zbeg = box_center[2] - 0.5 * box_size

    xend = box_center[0] + 0.5 * box_size #- box_grain
    yend = box_center[1] + 0.5 * box_size #- box_grain
    zend = box_center[2] + 0.5 * box_size #- box_grain

#    UI.messagebox [[xbeg,ybeg,zbeg],[xend,yend,zend]].inspect
    
    x1 = x2 = 0
    y1 = y2 = 0
    z1 = z2 = 0

#    UI.messagebox("assign")

    xbeg.step(xend, box_grain) do |i| 
      ybeg.step(yend, box_grain) do |j| 
	   zbeg.step(zend, box_grain) do |k| 

	  x1 = i
	  y1 = j
	  z1 = k

	  x = x1
	  y = y1
	  z = z1

	  $formula = formula

#	  UI.messagebox("preeval")
	    x2, y2, z2 = eval(formula)


	  pt1 = [x1, y1, z1]
	  pt2 = [x2, y2, z2]



	  [pt1, pt2].each{|pt| pt.collect! {|v| 
	      if v > 100000000.0
		100000000.0
	      elsif v < -100000000.0
		-100000000.0
	      else
		v
	      end
	    }
	  }


	  circ = entities.add_circle(pt1, pt2, 0.25 * box_grain, 12)
	  disk = entities.add_face(circ)
	  disk.material = "hazy yellow"
      disk.back_material = "hazy green"

	   end
      end
    end

    #-----------------------------------------------------------------------------
    view = model.active_view.zoom_extents 
    model.commit_operation
    #-----------------------------------------------------------------------------
end

if( not file_loaded?(__FILE__) )###
  utilities_menu = UI.menu("Plugins")
  utilities_menu.add_item("2-Plane Field") {graph_vector_field}
end
#-----------------------------------------------------------------------------
file_loaded(__FILE__)###
